#ifndef PLAYER_STATES_HPP
#define PLAYER_STATES_HPP

#include "state.hpp"

namespace godot {
class PlayerCharacter;
class StateMachine;
class TunnelsPlayer;

class PlayerState : public Node,
                    public IState {
    GDCLASS(PlayerState, Node);
    static void _bind_methods();
public:
    virtual void init(Node *target, StateMachine *machine) override;
    virtual StringName get_next() const override;
protected:
    PlayerCharacter *target{nullptr};
    StateMachine *state_machine{nullptr};
    TunnelsPlayer *player{nullptr};
};

class FollowingPlayer : public PlayerState {
    GDCLASS(FollowingPlayer, PlayerState);
    static void _bind_methods();
public:
    virtual void _process(double delta_time) override;
};
}

#endif // !PLAYER_STATES_HPP
